/*
 * Device Motion Gesture for JavaScript.
 * http://sourceforge.net/projects/jsmotiongesture/
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 * 
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU General Public License along
 * with the files in this library. If not, see  http://www.gnu.org/licenses
 * Distributed under the GNU Library or Lesser General Public License (LGPL)
 */

if(typeof Motion==="undefined"){Motion={}
}if(typeof Motion.Gesture==="undefined"){Motion.Gesture={}
}Motion.Gesture.Model={};
Motion.Gesture.Model.Control={};
Motion.Gesture.Model.Control.getStartTime=function(b){if(b.previous){var a=Motion.Gesture.Model.Control.getStartTime(b.previous)+(b.previous.window.time.width/2);
return a+b.window.time.delay
}else{return b.window.time.start
}};
Motion.Gesture.Model.Gesture={};
Motion.Gesture.Model.Gesture.isDefined=function(a){return(a.signature)
};
Motion.Gesture.Model.Serialisation={};
Motion.Gesture.Model.Serialisation.signatureFromJson=function(b){var a=JSON.parse(b);
Motion.Gesture.Model.Serialisation.restoreDeserialisedSignature(a);
return a
};
Motion.Gesture.Model.Serialisation.signatureToJson=function(a,b){return JSON.stringify(a,Motion.Gesture.Model.Serialisation.jsonSerialisationFilter,b)
};
Motion.Gesture.Model.Serialisation.jsonSerialisationFilter=function(a,b){if(a==="previous"){return undefined
}if(a==="signature"){return undefined
}return b
};
Motion.Gesture.Model.Serialisation.restoreDeserialisedSignature=function(a){for(var b=0;
b<a.roots.length;
b++){var c=a.roots[b];
while(c.next){c.next.previous=c;
c.signature=a;
c=c.next
}}};